#import "gTxtEditView.h"
#import <GraphicsServices/GraphicsServices.h>

@implementation gTxtEditTextView

- (id)initWithFrame:(CGRect)rect
{
	if(( self == [ super initWithFrame: rect ]) != nil)
		{
			[ self setDelegate: self ];
		}
	return self;
}



@end


@implementation gTxtEditView

- (id)initWithFrame:(CGRect)rect
{
	if(( self == [ super initWithFrame: rect ]) != nil)
		{
			topBar = [ [ UINavigationBar alloc ] initWithFrame: CGRectMake(rect.origin.x, rect.origin.y, rect.size.width, 45.0f) ];
			[ topBar setDelegate: self ];
				[ topBar showLeftButton:@"KB Hide" withStyle: 2 rightButton:@"Copy" withStyle: 0 ];
			topTitle = [ [ UINavigationItem alloc ] initWithTitle:@"New File" ];
			[ topBar pushNavigationItem: topTitle ];
			[ topBar enableAnimation ];	
		
			bottomBar = [ [ UINavigationBar alloc ] initWithFrame: CGRectMake(rect.origin.x, rect.origin.y + (rect.size.height - 45), rect.size.width, 45.0f) ];
			[ bottomBar setDelegate: self ];
			[ bottomBar showButtonsWithLeftTitle:@"Save" rightTitle:@"Open" leftBack:NO ];
			bottomTitle = [ [ UINavigationItem alloc ] initWithTitle:@"" ];
			[ bottomBar pushNavigationItem: bottomTitle ];
			[ bottomBar enableAnimation ];	
			
			fileView = [ [ gTxtEditTextView alloc ] initWithFrame: CGRectMake(rect.origin.x, rect.origin.y + 45, rect.size.width, rect.size.height - 91) ];
			[ fileView setDelegate: self ];
	

			[ self addSubview: topBar ];
			[ self addSubview: fileView ];
			[ self addSubview: bottomBar ];

			isEditing = FALSE;
			saved = FALSE;
			currentFile = nil;
			_path = @"/private/var/mobile/";
			_currentEncoding = NSShiftJISStringEncoding;
			[bottomTitle setTitle: @"[S-JIS]"];

		    _bSelectMode = FALSE;

			_preSelectText =[[NSMutableString alloc] initWithCapacity:1] ;
			_selectText = [[NSMutableString alloc] initWithCapacity:1] ;
			
//		    [fileView setEnabledGestures: 2];
//			[fileView setValue: [NSNumber numberWithBool: NO] forGestureAttribute: 7];
//			[fileView setValue: [NSNumber numberWithBool: NO] forGestureAttribute: 4];
//			[fileView setValue: [NSNumber numberWithBool: YES] forGestureAttribute: 5];
//			[fileView becomeFirstResponder]; 
		}
	return self;
}

- (void)textViewDidBeginEditing:(UITextView *)textView
{

	[ fileView setFrame: CGRectMake(0.0f, 45.0f, 320.0f, 230.0f) ];
	isEditing = TRUE;
}


- (void)textViewDidEndEditing:(UITextView *)textView
{
	[ fileView setFrame: CGRectMake(0.0f, 45.0f, 320.0f, [self bounds].size.height - 91) ];
	isEditing = FALSE;
}


- (void)loadFile:(NSString*)file
{

    _path = [file copy];
    /*[self updateFileTitle];*/
	_currentEncoding = [self inspectEncoding: _path];
	if(_currentEncoding == nil)
    {
	  _currentEncoding = NSShiftJISStringEncoding;
	}
	
	currentFile = [ [ NSString alloc ] 
			initWithData: [ [ NSFileManager defaultManager ] contentsAtPath: file ] encoding:_currentEncoding ];
			
	saved = FALSE;
	[ fileView setText: currentFile ];
	[ topTitle setTitle: [ file lastPathComponent ] ];
}

- (void)reset
{
	[ fileView setText: @"" ];
	[ topTitle setTitle:@"New File" ];
	saved = FALSE;
	currentFile = nil;
	_bSelectMode = FALSE;
}

- (void)saveToFile:(NSString*)file
{
	if(_currentEncoding == nil)
    {
	  _currentEncoding = NSShiftJISStringEncoding;
	}

	if(TRUE == [[fileView text] 
	   writeToFile: file 
	   atomically: NO 
	   encoding: _currentEncoding
	   error: nil])
	{
		saved = TRUE;
		currentFile = [ file copy ];
		[ topTitle setTitle: [ file lastPathComponent ] ];
		UIAlertSheet *alert = [[[UIAlertSheet alloc] init] autorelease];
			[alert setDelegate: self];
			[alert setTitle: @"Succeeded"];
			[alert addButtonWithTitle: @"OK"];
			[alert popupAlertAnimated: YES];
	}
	else
	{
		UIAlertSheet *alert = [[[UIAlertSheet alloc] init] autorelease];
			[alert setDelegate: self];
			[alert setTitle: @"Failed"];
			[alert addButtonWithTitle: @"OK"];
			[alert popupAlertAnimated: YES];	
	}
}

//- (void)autosave
//{
//	if(_currentEncoding == nil)
//  {
//	  _currentEncoding = NSShiftJISStringEncoding;
//	}
//
//	[[fileView text] 
//	   writeToFile: @"___autoSaveTxt" 
//	   atomically: NO 
//	   encoding: _currentEncoding
//	   error: nil];
//}


- (void)save
{
	if(_currentEncoding == nil)
    {
	  _currentEncoding = NSShiftJISStringEncoding;
	}
	
	if(TRUE == [[fileView text] 
	    writeToFile: currentFile
	    atomically: NO 
	    encoding: _currentEncoding
	    error: nil])
	{
		saved = TRUE;
		UIAlertSheet *alert = [[[UIAlertSheet alloc] init] autorelease];
			[alert setDelegate: self];
			[alert setTitle: @"Succeeded"];
			[alert addButtonWithTitle: @"OK"];
			[alert popupAlertAnimated: YES];
	}
	else
	{
		UIAlertSheet *alert = [[[UIAlertSheet alloc] init] autorelease];
			[alert setDelegate: self];
			[alert setTitle: @"Failed"];
			[alert addButtonWithTitle: @"OK"];
			[alert popupAlertAnimated: YES];	
	}
}


- (void)dealloc
{
	[ fileView release ];
	[ currentFile release ];
	[ bottomTitle release ];
	[ topTitle release ];
	[ bottomBar release ];
	[ topBar release ];
	[ super dealloc ];
}

- (void)navigationBar:(UINavigationBar*)bar buttonClicked:(int)button
{
	if(bar == bottomBar)
		{
			if(button == 1)
				{
					if(saved)
					{
						[ self save ];
					}
					else
					{
						[fileView resignFirstResponder];
						saveSheet = [ [ UIAlertSheet alloc ] init ];
						[ saveSheet setTitle:@"Save File" ];
						[ saveSheet setBodyText:@"Please enter a location to save to." ];
						[ saveSheet setContext:@"_saveSheet" ];
						[ saveSheet addButtonWithTitle:@"Save" ];
						[ saveSheet addButtonWithTitle:@"Cancel" ];
						[ saveSheet setDelegate: self ];
						[ saveSheet setNumberOfRows: 1 ];
						[ saveSheet addTextFieldWithValue:_path label: @"File Name" ];
						[ saveSheet popupAlertAnimated: YES ];
					}

					//[ self reset ];
				}
			else
				{
					[fileView resignFirstResponder];
					loadSheet = [ [ UIAlertSheet alloc ] init ];
					[ loadSheet setTitle:@"Load File" ];
					[ loadSheet setBodyText:@"Please enter a file to load. Make sure you have saved any changes to your current file before loading a new one." ];
					[ loadSheet setContext:@"_loadSheet" ];
					[ loadSheet addButtonWithTitle:@"New" ];
					[ loadSheet addButtonWithTitle:@"Load" ];
					[ loadSheet addButtonWithTitle:@"Cancel" ];
					[ loadSheet setDelegate: self ];
					[ loadSheet setNumberOfRows: 1 ];
					[ loadSheet addTextFieldWithValue:@"/private/var/mobile/" label: @"File Name"];
					[ loadSheet popupAlertAnimated: YES ];
				}
		}
	else
		{
			if(button == 1)
				{
					[fileView resignFirstResponder];
				
				}
			else
				{
					[ self copypaste ];
				}
		}
}

- (void)alertSheet:(UIAlertSheet*)sheet buttonClicked:(int)button
{
	if((sheet == saveSheet)||(sheet == loadSheet))
	{
		if(sheet == saveSheet)
			{
				if(button == 1)
					{
						[ self saveToFile: [ [ sheet textField ] text ] ];
						saved = TRUE;
					}
			}
		else if(sheet == loadSheet)
			{
				if(button == 1)
				{
					[ self reset ];
				}
				else if(button == 2)
				{
					[ self loadFile: [ [ sheet textField ] text ] ];
				}
			}
		[ sheet dismiss ];
		[ fileView setFrame: CGRectMake(0.0f, 45.0f, 320.0f, [self bounds].size.height - 91) ];
		isEditing = FALSE;
	}
	else
	{
		if( [sheet tag] == 1 ) 
		{
			if(1 == button)
			{
				[_selectText setString:_preSelectText];
				//Cut					
				NSMutableString* newText =  [NSMutableString stringWithCapacity:1];
				[newText appendString:[[fileView text] substringToIndex:_selectRange.location]];
				[newText appendString:[[fileView text] substringFromIndex:_selectRange.location + _selectRange.length]];
	    		[fileView setText:newText];
				_selectRange.length = 0;
	    		//[fileView setSelectionRange:_selectRange];
	    		fileView.selectedRange = _selectRange;
	
			}else if (2 == button)
			{
				[_selectText setString:_preSelectText];
			}
		}
		
		if( [sheet tag] == 2 ) 
		{
			if(1 == button)
			{
				//Paste
				if([_selectText length] > 0)
				{
					NSMutableString* newText = [NSMutableString stringWithCapacity:1];
					[newText appendString:[[fileView text] substringToIndex:_selectRange.location]];
					[newText appendString:[NSString stringWithString:_selectText]];
					[newText appendString:[[fileView text] substringFromIndex:_selectRange.location]];
	    			[fileView setText:newText];
	    			_selectRange.location = _selectRange.location +[_selectText length];
					_selectRange.length = 0;
					//[fileView setSelectionRange:_selectRange];
					fileView.selectedRange = _selectRange;
				}
			}
			if(2 == button)
			{
				//New Selecttion
				[_selectText setString:@""];
				//NSRange range = [fileView selectionRange];
				NSRange range = fileView.selectedRange;
				_textStart = range.location;
				_bSelectMode = TRUE;
			}
			if(3 == button)
			//Paste from Web
			{
				NSURL *url = [NSURL URLWithString:@"http://www.biocow.com/c/"];

    			NSHTTPCookieStorage *cookieJar = [NSHTTPCookieStorage sharedHTTPCookieStorage];
				//NSArray *Cookies = [cookieJar cookiesForURL:url];
				NSArray *Cookies = [cookieJar cookies];


				NSDate* expiresDateMax;
				NSString* copyValue;
				copyValue = nil;
				expiresDateMax =  [NSDate distantPast];
				for (NSHTTPCookie* cookie in Cookies) {
					NSString *cookieName = [cookie name];
					if([cookieName compare:@"gTxtEdit"] == NSOrderedSame)
					{

						NSDate* expiresDate = [cookie expiresDate];
						if(nil != expiresDate)
						{
							if([expiresDateMax compare:expiresDate] == NSOrderedAscending)
							{
								copyValue = [cookie value];
								expiresDateMax = expiresDate;
							}
						}
					
					}
    			}
    			if(nil != copyValue)
    			{
					NSMutableString* newText = [NSMutableString stringWithCapacity:1];
					[newText appendString:[[fileView text] substringToIndex:_selectRange.location]];
					[newText appendString:[NSString stringWithString:copyValue]];
					[newText appendString:[[fileView text] substringFromIndex:_selectRange.location]];
					[fileView setText:newText];
					_selectRange.location = _selectRange.location +[_selectText length];
					_selectRange.length = 0;
					//[fileView setSelectionRange:_selectRange];
					fileView.selectedRange = _selectRange;
				}

			}
		}


		[sheet dismissAnimated: YES];	
	}
	
}



- (NSStringEncoding)inspectEncoding: (NSString *)path
{
  id arp = [[NSAutoreleasePool alloc] init];

  NSStringEncoding encodings[] = {
    NSShiftJISStringEncoding, 
    NSUTF8StringEncoding,
    NSNonLossyASCIIStringEncoding,
    NSJapaneseEUCStringEncoding,
    NSMacOSRomanStringEncoding,
    NSWindowsCP1251StringEncoding,
    NSWindowsCP1252StringEncoding,
    NSWindowsCP1253StringEncoding,
    NSWindowsCP1254StringEncoding,
    NSWindowsCP1250StringEncoding,
    NSISOLatin1StringEncoding,
    NSUnicodeStringEncoding, 
    0
  };

  NSString* try_str;
  int i = 0;
  NSStringEncoding encoding;
  NSData* textData = 
    [[[NSData alloc] initWithContentsOfFile: path] autorelease];

  // may be ISO-2022-JP
  if (memchr([textData bytes], 0x1b, [textData length]) != NULL)
  {
    try_str =
      [[[NSString alloc] initWithData:textData
						 encoding: NSISO2022JPStringEncoding] autorelease];
    if (try_str != nil)
    {
      [bottomTitle setTitle: @"[ISO2022JP]"];
      return NSISO2022JPStringEncoding;
    }
  }

  // try to inspect encoding
  while(encodings[i] != 0)
  {
    try_str = [[[NSString alloc] initWithData:textData
								 encoding: encodings[i]] autorelease];
    if (try_str != nil)
    {
      encoding = encodings[i];
      break;
    }
    i++;
  }

   switch (encoding) {
   case NSUTF8StringEncoding:
     [bottomTitle setTitle: @"[UTF-8]"];
     break;
   case NSNonLossyASCIIStringEncoding:
	[bottomTitle setTitle: @"[ASCII]"];
     break;
   case NSJapaneseEUCStringEncoding:
	[bottomTitle setTitle: @"[EUC]"];
     break;
   case NSShiftJISStringEncoding:
	[bottomTitle setTitle: @"[S-JIS]"];
     break;
   case NSMacOSRomanStringEncoding:
	[bottomTitle setTitle: @"[MacOSRoman]"];
     break;
   case NSWindowsCP1251StringEncoding:
	[bottomTitle setTitle: @"[sCP1251]"];
     break;
   case NSWindowsCP1252StringEncoding:
	[bottomTitle setTitle: @"[CP1252]"];
     break;
   case NSWindowsCP1253StringEncoding:
	[bottomTitle setTitle: @"[CP1253]"];
     break;
   case NSWindowsCP1254StringEncoding:
	[bottomTitle setTitle: @"[ASCII]"];
     break;
   case NSWindowsCP1250StringEncoding:
	[bottomTitle setTitle: @"[CP1250]"];
     break;
   case NSISOLatin1StringEncoding:
	[bottomTitle setTitle: @"[ISOLatin1]"];
     break;
   case NSUnicodeStringEncoding:
	[bottomTitle setTitle: @"[Unicode]"];
     break;
   }

  return encoding;
  [arp release];
}

//- (BOOL)canHandleGestures
//{
//	return YES;
//}


//- (void)gestureEnded:(GSEvent*)event
//{
//			UIAlertSheet *alert = [[[UIAlertSheet alloc] init] autorelease];
//			[alert setDelegate: self];
//			[alert setTitle: @"Select Start"];
//			[alert addButtonWithTitle: @"OK"];
//			[alert popupAlertAnimated: YES];
//}

- (void)copypaste
{
	[fileView becomeFirstResponder]; 
	if(FALSE == _bSelectMode)
	{

		NSRange range = fileView.selectedRange;
	
		_textStart = range.location;

		if(0 == [_selectText length])
		{
			UIAlertSheet *alert = [[[UIAlertSheet alloc] init] autorelease];
			[alert setDelegate: self];
			[alert setTitle: @"Select Start"];
			[alert addButtonWithTitle: @"OK"];
			//[alert popupAlertAnimated: YES];
			[alert popupAlertAnimated: NO];

			_bSelectMode = TRUE;
		}
		else
		{
			//Paste
			_selectRange.location = _textStart;
			UIAlertSheet *alert = [[[UIAlertSheet alloc] init] autorelease];
			[alert setDelegate: self];
			[alert setTitle: @"Clipboard"];
			[alert addButtonWithTitle: @"Paste"];
			[alert addButtonWithTitle: @"NewSel"];
			[alert addButtonWithTitle: @"WebPaste"];
			[alert addButtonWithTitle: @"Cancel"];
			//[alert setNumberOfRows: 1 ];
			[alert setBodyText:_selectText];
			[alert setBodyTextMaxLineCount:5];
//			[alert popupAlertAnimated: YES];
			[alert popupAlertAnimated: NO];

			[alert setTag: 2];
		}
	}
	else
	{
		NSRange range = fileView.selectedRange;

		if(_textStart != range.location)
		{
			if(_textStart < range.location)
			{
				_selectRange.location = _textStart;
				_selectRange.length =  range.location - _textStart;
			}
			else
			{
				_selectRange.location = range.location ;
				_selectRange.length =  _textStart - range.location ;		
			}
			_preSelectText = [[fileView text] substringWithRange:_selectRange];
			
			UIAlertSheet *alert = [[[UIAlertSheet alloc] init] autorelease];
			[alert setDelegate: self];
			[alert setTitle: @"Clipboard"];
			[alert addButtonWithTitle: @"Cut"];
			[alert addButtonWithTitle: @"Copy"];
			[alert addButtonWithTitle: @"Cancel"];
			[alert setNumberOfRows: 1 ];
			[alert setBodyText:_preSelectText];
			[alert setBodyTextMaxLineCount:5];
//			[alert popupAlertAnimated: YES];
			[alert popupAlertAnimated: NO];

			[alert setTag: 1];
						
			_bSelectMode = FALSE;
        	
		}
	
	}
}

@end